#include <dos.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>

#define I asm
#define uchar unsigned char
#define uint unsigned int
#define vbuf (uchar far *)0xA0000000

#define NP 150
// Coefficiente di inerzia: K=0->massimo K > 0 minore al crescere di K

#define NUM_DEL 0

uchar page[65535];
uchar image[65535];

float px[NP], py[NP];


void put_pixel(int x, int y, uchar col, uchar *dest)
{
if((uint)x < 320 && (uint)y<200)
 *(dest + x + /*(y<<6) + (y<<8)*/ y*320) = col;
}



#define WORD uint
void shade(uchar *dest, int decay)
{
WORD dest_seg = FP_SEG(dest);
WORD dest_off = FP_OFF(dest);
asm{
push si
push di

mov dx, decay

push dest_seg
pop  es
mov  di, dest_off


cld
xor di, di
}
shade_loop:
asm{
xor bh, bh
mov al, byte ptr es:[di-320]
mov bl, byte ptr es:[di+320]
add ax, bx
mov bl, byte ptr es:[di+1]
add ax, bx
mov bl, byte ptr es:[di-1]
add ax, bx
jz none
shr ax, 2
jz none
cmp ax, dx
jg decrease_it
xor ax, ax
jmp none
}
decrease_it:

asm sub ax, dx

none:
asm{

stosb
cmp di, 65534
jne shade_loop


pop  di
pop  si
}
}




void calc_light(uchar *src, uchar *dest)
{
WORD src_seg=FP_SEG(src);
WORD src_off=FP_OFF(src);
WORD dest_seg=FP_SEG(dest);
WORD dest_off=FP_OFF(dest);

asm{
push si
push di
push ds

push dest_seg
pop  es
mov  di, dest_off

//mov si, src_off
push src_seg
pop  ds

cld
}

light_loop:
asm{
mov al, byte ptr ds:[di-1]
mov bl, byte ptr ds:[di-320]
sub ax, bx
add ax, 128
cmp ax, 255
jle no_max
mov ax, 255
jmp done
}
no_max:
I cmp ax, 0
I jge done
I xor ax, ax

done:
asm{

 stosb

cmp di, 64000-1
jne light_loop

pop  ds
pop  di
pop  si
}

}



void displace_draw(uchar *src, uchar *dest, uchar *d_map)
{
uint off=0, d_off;
int norm_x, norm_y;

for(off=0; off<64000; off++)
{
 norm_x = (d_map[off+1] - d_map[off-1])>>3;

 norm_y = (d_map[off+320] - d_map[off-320])>>3;

 d_off = norm_x + 320*norm_y + off;
 *(dest + off) = *(src + d_off);
}
}















void draw_line(int x1, int y1, int x2, int y2, uchar col, uchar *dest)
{
  int i, deltax, deltay, numpixels, d, dinc1, dinc2, x, xinc1, xinc2,
  y, yinc1, yinc2;

  if (x1 < 0) x1 = 0; else if (x1 > 319) x1 = 319;
  if (x2 < 0) x2 = 0; else if (x2 > 319) x2 = 319;
  if (y1 < 0) y1 = 0; else if (y1 > 198) y1 = 198;
  if (y2 < 0) y2 = 0; else if (y2 > 198) y2 = 198;

  deltax = x2 - x1; if(deltax<0) deltax=-deltax;
  deltay = y2 - y1; if(deltay<0) deltay=-deltay;

  if (deltax >= deltay)
    {
      numpixels = deltax + 1;
      d = (deltay<<1) - deltax;
      dinc1 = deltay<<1;
      dinc2 = (deltay - deltax) << 1;
      xinc1 = 1; xinc2 = 1; yinc1 = 0; yinc2 = 1;
    }
  else
    {
      numpixels = deltay + 1;
      d = (deltax<<1) - deltay;
      dinc1 = deltax << 1;
      dinc2 = (deltax - deltay) << 1;
      xinc1 = 0; xinc2 = 1; yinc1 = 1; yinc2 = 1;
    }

  if (x1 > x2) { xinc1 = - xinc1; xinc2 = - xinc2; }
  if (y1 > y2) { yinc1 = - yinc1; yinc2 = - yinc2; }

  x = x1;
  y = y1;

  for (i=0; i < numpixels; i++)
    {
      uint off = x + (y<<6) + (y<<8);
      *(dest + off) = col;
     // off+=320;
     // *(dest + off) = col;

      if (d < 0)
	{
	  d = d + dinc1;
	  x = x + xinc1;
	  y = y + yinc1;
	}
      else
	{
	  d = d + dinc2;
	  x = x + xinc2;
	  y = y + yinc2;
	}
    }
}





void move_line(int x, int y, float K, uchar *dest)
{
int opx, opy, i;
int x1, y1, x2, y2;

 px[0] = x;
 py[0] = y;
for(i=1; i<NP; i++)
{
 opx = px[i];
 opy = py[i];
 px[i] = (px[i] + px[i-1]) / (2.0 + K / NP);
 py[i] = (py[i] + py[i-1]) / (2.0 + K / NP);
 x1 = px[i];
 y1 = py[i];
 x2 = px[i-1];
 y2 = py[i-1];
/*
 put_pixel(x1, y1, 255, dest);
 put_pixel(319-x1, y1, 255, dest);
 put_pixel(x1, 199-y1, 255, dest);
 put_pixel(319-x1, 199-y1, 255, dest);
*/
 draw_line(x1, y1, x2, y2, 255, dest);
 draw_line(319-x1, 199-y1, 319-x2, 199-y2, 255, dest);
 draw_line(x1, 199-y1, x2, 199-y2, 255, dest);
 draw_line(319-x1, y1, 319-x2, y2, 255, dest);

}
}




void move_screen(uchar *src, uchar *dest, uint len)
{
WORD src_s, src_o;
WORD dest_s, dest_o;
src_s = FP_SEG(src);
src_o = FP_OFF(src);
dest_s = FP_SEG(dest);
dest_o = FP_OFF(dest);

asm{
push si
push di
push ds

mov cx, len
shr cx, 1


push dest_s
pop  es
mov di, dest_o

push src_s
pop  ds
mov si, src_o


   cld
   rep movsw


pop  ds
pop di
pop si
}

}


void wait_retrace(void)
{
 I mov dx, 3dah
 _rt_loop1:
 I in al, dx
 I test al, 8
 I jnz _rt_loop1

 _rt_loop2:
 I in al, dx
 I test al, 8
 I jz _rt_loop2
}




void set_phong_pal(int n, int mx)
{
int i, r, g, b;
float k;
outp(968, 1);
for(i=1; i<256; i++)
{
k = pow(sin(M_PI/511.0*i), n) * mx + ( 32.0 * pow((float)i/256.0, 3) );
if(k>63) k=63;
b = i/4;
r = k;
g = k;
outp(969, r);
outp(969, g);
outp(969, b);
}
}



void main(void)
{
int i, j;
float a, aa, rx, ry, x, y;
int xx, yy;

I mov ax, 13h
I int 10h

set_phong_pal(8, 64);

for(i=0; i<320; i++)
for(j=0; j<200; j++)
image[i+j*320] =(
244.0 * ((float)(i+j)/(319.0+199.0))+
image[(i-1)+j*320] +
image[i+(j-1)*320] +
image[(i-1)+(j-1)*320] +
rand()%32
)/4;

shade(image, 1);


int ik=0;
while(ik < 3)
{

a+=0.025;
rx=fabs(sin(sin(a/4.1)*M_PI)*90)+9;
ry=fabs(cos(cos(a/1.3)*M_PI)*90)+9;
x=cos(cos(a/2.0)*M_PI)*rx;
y=sin(cos(a/2.7)*M_PI)*ry;

aa = a/1.37;
xx = x* cos(aa) + y*sin(aa);
yy = x*-sin(aa) + y*cos(-aa);


move_line(159.0/99.0*xx+160, yy+100, sin(a/15.0)*1.0+0.75, page);


if(ik==0)
{
 shade(page, sin(aa/8.0)*4+5);
 move_screen(page, vbuf, 64000);
}
if(ik==1)
{
 shade(page, sin(aa/8.0)*4+5);
 calc_light(page, vbuf);
}
if(ik==2)
{
 shade(page, sin(aa/8.0)*3+6);
 displace_draw(image, vbuf, page);
}

if(kbhit()){if(getch()==27) break; ik++;}

}

I mov ax, 3
I int 10h

}

